```bash
npm/yarn/pnpm create @tobiastengler/relay-app@latest [options]
```

### -y, --yes

Skips any prompts and chooses [default values](./default-values.md) for options that weren't supplied as CLI arguments.

### -t, --toolchain &lt;toolchain&gt;

The toolchain, e.g. bundler and configuration, your project was setup with.

_Possible values_

- cra [_Create React App_](https://create-react-app.dev/)
- vite [_Vite.js_](https://vitejs.dev/)
- next [_Next.js_](https://nextjs.org/)

_Example_

```bash
--toolchain vite
```

### --typescript

If specified, we assume your project is built with Typescript.

### -f, --schema-file &lt;path&gt;

Specifies the location of the GraphQL schema file inside of your project directory.

_Possible values_

A path relative to the root directory of your project and ending in the `.graphql` extension.

_Example_

```bash
--schema-file ./src/schema.graphql
```

### -s, --src &lt;path&gt;

Specifies the source directory of your project, where the Relay compiler will be run on.

_Possible values_

A relative path to a directory inside the root directory of your project.

_Example_

```bash
--src ./src
```

### -a, --artifact-directory &lt;path&gt;

Specifies a directory, where all artifacts generated by the Relay compiler will be placed.

_Possible values_

A relative path to a directory inside the root directory of your project.

_Example_

```bash
--artifact-directory ./src/__generated__
```

### --subscriptions

If specified, we will setup subscriptions via [graphql-ws](https://github.com/enisdenjo/graphql-ws) in your network layer.

### -p, --package-manager &lt;manager&gt;

Specify the Node.js package manager to use when packages need to be installed.

_Possible values_

- npm
- yarn
- pnpm

_Example_

```bash
--package-manager yarn
```

### --ignore-git-changes

If specified, the script will not exit, if it's run in a directory with un-commited Git changes.

### --skip-install

Skips the install of npm packages.

**This is only to be meant to use for testing!**

### -v, --version

Displays the current version of the script.

### -h, --help

Displays information about all of the available options.
